# pcgames.tcl v1.8 by domsen <domsen@domsen.org> (c)2oo3
#
# comments? bugs? ideas? requests? money? beer? 
# plz mail me or visit my homepage @ www.domsen.org
# also check out www.uid-zero.de
#
# das tcl liest  die www.pcgames.de  news aus und gibt  sie wieder,  gleich mit
# dem link zum eigentlichen artikel. per trigger lassen sich auch die letzten X
# news von hand auslesen.
#
# v1.8 - komplett umgebaut by public request
#      - link wird gleich mitgepostet
#      - yeah  endlich  keine  windrop  user  mehr die mich fragen was lynx ist
#        so gerne ich support leiste - jeden tag ne  mail mit der  selben frage
#        stresst ziemlich ;)
#
# pcgamestrigger - der trigger auf den der bot reagiert (public und message)
# pcgameslimit - maximum der news die auf befehl geposted werden
# pcgamesnewspost  - 1 fr newsposting, 0 fr keines
# pcgameschans  - die  chans in  denen das tcl aktiv  ist, "" fr alle
# pcgamesnewspostlimit - maximum der news die geposted werden
# ispcgameshub  - legt fest ob der bot newshub ist oder nicht
# pcgamesleafs  - die nicks der leafbots auf denen das leaf tcl luft
#
####### config ######################

set pcgamestrigger ".pcgames"
set pcgameschans ""
set pcgameslimit "5"
set pcgamesnewspostlimit "3"
set pcgamesnewspost "1"
set ispcgameshub "0"
set pcgamesleafs ""

####### ende der config #############

bind msg - $pcgamestrigger msg_pcgames
bind pub - $pcgamestrigger pub_pcgames
bind time - "?0 * * * *" pcgamescheck

proc sendpcgamesnews { arg } {
global pcgamesleafs
foreach bot [bots] {
if {([lsearch -exact [string tolower $pcgamesleafs] [string tolower $bot]] != -1)} {
putbot $bot "pcgames: $arg"
}}}

proc shrink { calc number string start bl} { return [expr [string first "$string" $bl $start] $calc $number] }

proc pcgamesnews { target limit } {
if {[catch {set sock [socket www.pcgames.de 80] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET  /index.cfm?menu=0101 HTTP/1.1"
puts $sock "User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)"
puts $sock "Host: www.pcgames.de"
puts $sock "Connection: close"
puts $sock ""
flush $sock
set counter 0
while {[eof $sock] != 1} {
set bl [gets $sock]
if {[string first "<a href=\"/?article_id=" $bl] != -1} {
set link "www.pcgames.de[string range $bl [shrink + 7 " href=\"" 0 $bl] [shrink - 1 "\">" 60 $bl]]"
set newsline [string range $bl [shrink + 2 "\">" 60 $bl] [shrink - 1 "</a>" 0 $bl]]
putserv "privmsg $target :[incr counter] $newsline <$link>"
}
if {$counter == $limit} {close $sock; return 0}
}}}


proc pcgamescheck {nick uhost hand chan arg} {
global pcgameschans pcgamesnewspost ispcgameshub pcgamesnewspostlimit
set counter 0
if {$pcgamesnewspost == 1 } {
putlog "pcgames: suche nach neuer newsline"
set pcgameslastnews "none"
if {[file exists pcgames.hdl]} {
set temp [open "pcgames.hdl" r]
set pcgameslastnews "[gets $temp]"
if {$pcgameslastnews == ""} { set pcgameslastnews "none" }
close $temp
}
set temp [open "pcgames.hdl" w+]
if {[catch {set sock [socket www.pcgames.de 80] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET /index.cfm?menu=0101 HTTP/1.1"
puts $sock "User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)"
puts $sock "Host: www.pcgames.de"
puts $sock "Connection: close"
puts $sock ""
flush $sock
while {[eof $sock] != 1} {
set bl [gets $sock]
if {[string first "<a href=\"/?article_id=" $bl] != -1} {
set link "www.pcgames.de[string range $bl [shrink + 7 " href=\"" 0 $bl] [shrink - 1 "\">" 60 $bl]]"
set newsline [string range $bl [shrink + 2 "\">" 60 $bl] [shrink - 1 "</a>" 0 $bl]]
puts $temp "$newsline <$link>"
}}}
close $sock ; close $temp
if {$pcgameslastnews == "none" } { putlog "pcgames: headlinefile created" ; return 0 }
set temp [open "pcgames.hdl" r]
while { [eof $temp] != 1 } {
set pcgamesneunews [gets $temp]
if {($pcgameslastnews == $pcgamesneunews) || ($counter == $pcgamesnewspostlimit)} { close $temp;return 0 }
incr counter
foreach chan [channels] {
if {$pcgameschans == "" } { putserv "privmsg $chan :(neue pcgames.de newsline) $pcgamesneunews" }
if {$pcgameschans != "" } {
if {([lsearch -exact [string tolower $pcgameschans] [string tolower $chan]] != -1) || ($pcgameschans == "")} {putserv "privmsg $chan :(neue pcgames.de newsline) $pcgamesneunews"}
}
if { $ispcgameshub == "1" } { sendpcgamesnews $pcgamesneunews }
}}}}


proc msg_pcgames { nick uhost hand arg } { global pcgameslimit ; pcgamesnews $nick $pcgameslimit }
proc pub_pcgames { nick uhost hand chan arg } { global pcgameschans pcgameslimit ; if {([lsearch -exact [string tolower $pcgameschans] [string tolower $chan]] != -1) || ($pcgameschans == "")} { pcgamesnews $nick $pcgameslimit }}


putlog "*** pcgames.tcl v1.8 by domsen <domsen@domsen.org> succesfully loaded"

#[EOF]
